diff --git a/test/unit/web/app_bundle_test.rb b/test/unit/web/app_bundle_test.rb
new file mode 100644
index 00000000..a55fad2c
--- /dev/null
+++ b/test/unit/web/app_bundle_test.rb
@@ -0,0 +1,573 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/web/app_bundle"
+require "digest"
+require "rubygems/package"
+require "zlib"
+
+class WebAppBundleTest < Minitest::Test
+  include HiveTestHelper
+
+  def build(dir, **opts)
+    Hive::Web::AppBundle.new(
+      version: opts.delete(:version) || "9.9.9",
+      data_home: dir,
+      source_app_dir: opts.delete(:source_app_dir),
+      env: opts.delete(:env) || {},
+      downloader: opts.delete(:downloader) || ->(_url, _dest) { raise "network unexpected" },
+      bundler: opts.delete(:bundler) || ->(_app_dir) { nil },
+      **opts
+    )
+  end
+
+  def write_rails_tree(root)
+    FileUtils.mkdir_p(File.join(root, "config"))
+    File.write(File.join(root, "config", "application.rb"), "# rails marker\n")
+    File.write(File.join(root, "Gemfile"), "source 'https://rubygems.org'\n")
+    root
+  end
+
+  def build_tar_gz(archive_path, entries)
+    # entries: { "path" => content_string_or_nil_for_dir }
+    Zlib::GzipWriter.open(archive_path) do |gz|
+      Gem::Package::TarWriter.new(gz) do |tar|
+        entries.each do |name, content|
+          if content.nil?
+            tar.mkdir(name, 0o755)
+          else
+            tar.add_file_simple(name, 0o644, content.bytesize) { |io| io.write(content) }
+          end
+        end
+      end
+    end
+  end
+
+  def checksum_for(path, basename: File.basename(path))
+    "#{Digest::SHA256.file(path).hexdigest}  #{basename}\n"
+  end
+
+  def test_current_stamped_bundle_reused_without_network_or_bundler
+    with_tmp_dir do |dir|
+      target = File.join(dir, "web-app")
+      write_rails_tree(target)
+      File.write(File.join(target, ".hive-web-version"), "9.9.9\n")
+
+      network_called = false
+      bundler_called = false
+      bundle = build(
+        dir,
+        downloader: ->(*) { network_called = true },
+        bundler: ->(*) { bundler_called = true }
+      )
+
+      path = bundle.resolve!
+      assert_equal target, path
+      refute network_called
+      refute bundler_called
+      assert bundle.current_managed_bundle?
+    end
+  end
+
+  def test_missing_bundle_installs_from_directory_fixture_and_stamps_version
+    with_tmp_dir do |dir|
+      source = write_rails_tree(File.join(dir, "fixture-app"))
+      bundler_dirs = []
+      bundle = build(dir, bundler: ->(app_dir) { bundler_dirs << app_dir })
+
+      path = bundle.ensure_installed!(source: source)
+      assert_equal File.join(dir, "web-app"), path
+      assert File.file?(File.join(path, "config", "application.rb"))
+      assert_equal "9.9.9", File.read(File.join(path, ".hive-web-version")).strip
+      assert_equal 1, bundler_dirs.length
+      assert_match(/web-app\.staging\./, bundler_dirs.first,
+                   "bundle install must run against the staging tree before the atomic swap")
+      assert bundle.current_managed_bundle?
+    end
+  end
+
+  def test_install_from_release_archive_records_version
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "hive-web-9.9.9.tar.gz")
+      build_tar_gz(archive, {
+        "config/" => nil,
+        "config/application.rb" => "# rails\n",
+        "Gemfile" => "source 'https://rubygems.org'\n"
+      })
+
+      downloader = lambda do |url, dest|
+        case File.basename(url)
+        when "SHA256SUMS"
+          File.write(dest, checksum_for(archive))
+        when "hive-web-9.9.9.tar.gz"
+          FileUtils.cp(archive, dest)
+        else
+          flunk "unexpected download: #{url}"
+        end
+      end
+      bundle = build(dir, downloader: downloader)
+      path = bundle.ensure_installed!
+      assert_equal "9.9.9", File.read(File.join(path, ".hive-web-version")).strip
+      assert File.file?(File.join(path, "config", "application.rb"))
+    end
+  end
+
+  def test_release_install_rejects_checksum_mismatch_before_extraction
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "hive-web-9.9.9.tar.gz")
+      build_tar_gz(archive, {
+        "config/" => nil,
+        "config/application.rb" => "# rails\n",
+        "Gemfile" => "source 'https://rubygems.org'\n"
+      })
+      downloader = lambda do |url, dest|
+        if File.basename(url) == "SHA256SUMS"
+          File.write(dest, "#{'0' * 64}  hive-web-9.9.9.tar.gz\n")
+        else
+          FileUtils.cp(archive, dest)
+        end
+      end
+
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        build(dir, downloader: downloader).ensure_installed!
+      end
+
+      assert_match(/checksum mismatch/, error.message)
+      refute File.exist?(File.join(dir, "web-app"))
+    end
+  end
+
+  def test_release_install_requires_an_exact_checksum_entry
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "hive-web-9.9.9.tar.gz")
+      build_tar_gz(archive, { "config/application.rb" => "# rails\n" })
+      downloader = lambda do |url, dest|
+        if File.basename(url) == "SHA256SUMS"
+          File.write(dest, "#{Digest::SHA256.file(archive).hexdigest}  another-file.tar.gz\n")
+        else
+          FileUtils.cp(archive, dest)
+        end
+      end
+
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        build(dir, downloader: downloader).ensure_installed!
+      end
+      assert_match(/does not contain hive-web-9\.9\.9\.tar\.gz/, error.message)
+    end
+  end
+
+  def test_release_install_verifies_signed_checksums_when_cosign_is_available
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "hive-web-9.9.9.tar.gz")
+      build_tar_gz(archive, {
+        "config/application.rb" => "# rails\n",
+        "Gemfile" => "source 'https://rubygems.org'\n"
+      })
+      bin = File.join(dir, "bin")
+      FileUtils.mkdir_p(bin)
+      cosign = File.join(bin, "cosign")
+      File.write(cosign, "#!/bin/sh\nexit 0\n")
+      FileUtils.chmod(0o755, cosign)
+      downloads = []
+      downloader = lambda do |url, dest|
+        downloads << File.basename(url)
+        case File.basename(url)
+        when "SHA256SUMS"
+          File.write(dest, checksum_for(archive))
+        when "SHA256SUMS.sig", "SHA256SUMS.pem"
+          File.write(dest, "provenance\n")
+        when "hive-web-9.9.9.tar.gz"
+          FileUtils.cp(archive, dest)
+        else
+          flunk "unexpected download: #{url}"
+        end
+      end
+      success = Struct.new(:success?).new(true)
+      verify_argv = nil
+      runner = lambda do |*argv, **kwargs|
+        verify_argv = argv
+        assert_equal 60, kwargs.fetch(:timeout)
+        [ "Verified OK", "", success ]
+      end
+
+      bundle = build(
+        dir,
+        env: { "PATH" => bin },
+        downloader: downloader,
+        subprocess_runner: runner
+      )
+      bundle.ensure_installed!
+
+      assert_equal(
+        %w[SHA256SUMS SHA256SUMS.sig SHA256SUMS.pem hive-web-9.9.9.tar.gz],
+        downloads
+      )
+      assert_equal cosign, verify_argv.first
+      assert_includes verify_argv, "--certificate-identity-regexp"
+      assert_includes verify_argv, "^https://github\\.com/#{Hive::REPO_OWNER}/#{Hive::REPO_NAME}/"
+      assert_includes verify_argv, "https://token.actions.githubusercontent.com"
+    end
+  end
+
+  def test_failed_refresh_leaves_previous_bundle_intact
+    with_tmp_dir do |dir|
+      target = File.join(dir, "web-app")
+      write_rails_tree(target)
+      File.write(File.join(target, ".hive-web-version"), "9.9.9\n")
+      File.write(File.join(target, "keep-me"), "old\n")
+
+      source = write_rails_tree(File.join(dir, "new-source"))
+      File.write(File.join(source, "new-file"), "new\n")
+
+      bundle = build(
+        dir,
+        version: "10.0.0",
+        bundler: ->(_app_dir) { raise Hive::Web::AppBundle::Error, "bundle explode" }
+      )
+
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        bundle.ensure_installed!(source: source)
+      end
+      assert_match(/bundle explode/, error.message)
+
+      assert File.exist?(target), "previous bundle must remain"
+      assert_equal "old\n", File.read(File.join(target, "keep-me"))
+      assert_equal "9.9.9", File.read(File.join(target, ".hive-web-version")).strip
+      refute File.exist?(File.join(target, "new-file"))
+      refute Dir.glob(File.join(dir, "web-app.staging.*")).any?
+      refute Dir.glob(File.join(dir, "web-app.prev.*")).any?
+    end
+  end
+
+  def test_failed_first_install_leaves_no_half_provisioned_target
+    with_tmp_dir do |dir|
+      source = write_rails_tree(File.join(dir, "fixture-app"))
+      bundle = build(
+        dir,
+        bundler: ->(_app_dir) { raise Hive::Web::AppBundle::Error, "no gems" }
+      )
+
+      assert_raises(Hive::Web::AppBundle::Error) { bundle.ensure_installed!(source: source) }
+      refute File.exist?(File.join(dir, "web-app"))
+      refute Dir.glob(File.join(dir, "web-app.staging.*")).any?
+    end
+  end
+
+  def test_archive_rejects_path_traversal
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "bad.tar.gz")
+      build_tar_gz(archive, {
+        "../escape/config/application.rb" => "# no\n"
+      })
+      bundle = build(dir)
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        bundle.extract_and_install!(archive)
+      end
+      assert_match(/escapes staging root|absolute path/, error.message)
+      refute File.exist?(File.join(dir, "web-app"))
+    end
+  end
+
+  def test_archive_rejects_absolute_paths
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "abs.tar.gz")
+      build_tar_gz(archive, {
+        "/tmp/evil/config/application.rb" => "# no\n"
+      })
+      bundle = build(dir)
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        bundle.extract_and_install!(archive)
+      end
+      assert_match(/absolute path/, error.message)
+    end
+  end
+
+  def test_archive_rejects_symlinks
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "link.tar.gz")
+      Zlib::GzipWriter.open(archive) do |gz|
+        Gem::Package::TarWriter.new(gz) do |tar|
+          tar.add_symlink("link-to-elsewhere", "/etc/passwd", 0o777)
+        end
+      end
+      bundle = build(dir)
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        bundle.extract_and_install!(archive)
+      end
+      assert_match(/link entry/, error.message)
+    end
+  end
+
+  def test_archive_rejects_missing_rails_marker
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "empty.tar.gz")
+      build_tar_gz(archive, {
+        "README.md" => "no rails here\n"
+      })
+      bundle = build(dir)
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        bundle.extract_and_install!(archive)
+      end
+      assert_match(/does not contain a Rails app/, error.message)
+    end
+  end
+
+  def test_archive_rejects_too_many_entries
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "many.tar.gz")
+      build_tar_gz(archive, {
+        "config/" => nil,
+        "config/application.rb" => "# rails\n",
+        "Gemfile" => "source 'https://rubygems.org'\n"
+      })
+
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        build(dir, max_archive_entries: 2).extract_and_install!(archive)
+      end
+      assert_match(/too many entries/, error.message)
+    end
+  end
+
+  def test_archive_rejects_oversized_compressed_input
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "oversized.tar.gz")
+      build_tar_gz(archive, { "config/application.rb" => "# rails\n" })
+
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        build(dir, max_archive_bytes: 1).extract_and_install!(archive)
+      end
+      assert_match(/archive is too large/, error.message)
+    end
+  end
+
+  def test_archive_rejects_an_oversized_entry
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "large-entry.tar.gz")
+      build_tar_gz(archive, { "config/application.rb" => "12345" })
+
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        build(dir, max_archive_entry_bytes: 4).extract_and_install!(archive)
+      end
+      assert_match(/entry is too large/, error.message)
+    end
+  end
+
+  def test_archive_rejects_excessive_cumulative_expansion
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "expanded.tar.gz")
+      build_tar_gz(archive, {
+        "config/application.rb" => "1234",
+        "Gemfile" => "5678"
+      })
+
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        build(dir, max_archive_expanded_bytes: 7).extract_and_install!(archive)
+      end
+      assert_match(/expanded contents are too large/, error.message)
+    end
+  end
+
+  def test_single_versioned_wrapper_directory_is_unwrapped
+    with_tmp_dir do |dir|
+      archive = File.join(dir, "wrapped.tar.gz")
+      build_tar_gz(archive, {
+        "hive-web-9.9.9/" => nil,
+        "hive-web-9.9.9/config/" => nil,
+        "hive-web-9.9.9/config/application.rb" => "# rails\n",
+        "hive-web-9.9.9/Gemfile" => "source 'https://rubygems.org'\n"
+      })
+      bundle = build(dir)
+      path = nil
+      # install via extract path
+      Dir.mktmpdir do |_tmp|
+        path = bundle.tap { |b| b.extract_and_install!(archive) }.managed_app_dir
+      end
+      assert File.file?(File.join(path, "config", "application.rb"))
+      refute File.exist?(File.join(path, "hive-web-9.9.9"))
+    end
+  end
+
+  def test_explicit_env_override_wins_without_managed_bootstrap
+    with_tmp_dir do |dir|
+      override = write_rails_tree(File.join(dir, "override-app"))
+      network_called = false
+      bundle = build(
+        dir,
+        env: { "HIVEBOX_WEB_APP_DIR" => override },
+        downloader: ->(*) { network_called = true }
+      )
+      assert_equal override, bundle.resolve!
+      refute network_called
+      refute File.exist?(File.join(dir, "web-app"))
+    end
+  end
+
+  def test_source_checkout_wins_over_download_when_present
+    with_tmp_dir do |dir|
+      source = write_rails_tree(File.join(dir, "checkout-web"))
+      network_called = false
+      bundle = build(
+        dir,
+        source_app_dir: source,
+        downloader: ->(*) { network_called = true }
+      )
+      assert_equal source, bundle.resolve!
+      refute network_called
+    end
+  end
+
+  def test_default_source_checkout_fallback_resolves_repository_web_directory
+    with_tmp_dir do |dir|
+      bundle = build(dir, source_app_dir: File.join(dir, "missing"))
+      expected = File.expand_path("../../../web", File.join(__dir__, "../../../lib/hive/web"))
+
+      assert_equal expected, bundle.resolve!
+    end
+  end
+
+  def test_runtime_env_is_private_to_the_managed_bundle
+    with_tmp_dir do |dir|
+      bundle = build(dir)
+      managed = bundle.managed_app_dir
+
+      assert_equal(
+        {
+          "BUNDLE_APP_CONFIG" => File.join(managed, ".bundle"),
+          "BUNDLE_GEMFILE" => File.join(managed, "Gemfile"),
+          "BUNDLE_PATH" => File.join(managed, "vendor", "bundle"),
+          "BUNDLE_DEPLOYMENT" => "1",
+          "BUNDLE_WITHOUT" => "development:test",
+          "RAILS_ENV" => "production"
+        },
+        bundle.runtime_env(managed)
+      )
+      assert_empty bundle.runtime_env(File.join(dir, "source-web"))
+    end
+  end
+
+  def test_https_redirect_to_http_is_rejected
+    redirect = Net::HTTPFound.new("1.1", "302", "Found")
+    redirect["location"] = "http://downloads.example.test/hive-web-9.9.9.tar.gz"
+    http_factory = ->(_uri) { FakeHttp.new(redirect) }
+
+    with_tmp_dir do |dir|
+      bundle = Hive::Web::AppBundle.new(
+        version: "9.9.9", data_home: dir, env: {}, http_factory: http_factory,
+        bundler: ->(*) { nil }
+      )
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        bundle.send(
+          :default_download,
+          "https://downloads.example.test/hive-web-9.9.9.tar.gz",
+          File.join(dir, "archive"),
+          max_bytes: 100
+        )
+      end
+      assert_match(/refusing HTTPS to HTTP redirect/, error.message)
+    end
+  end
+
+  def test_download_stream_is_bounded_by_explicit_ceiling
+    response = Net::HTTPOK.new("1.1", "200", "OK")
+    response.define_singleton_method(:read_body) do |&block|
+      block.call("1234")
+      block.call("5678")
+    end
+    http_factory = ->(_uri) { FakeHttp.new(response) }
+
+    with_tmp_dir do |dir|
+      dest = File.join(dir, "archive")
+      bundle = Hive::Web::AppBundle.new(
+        version: "9.9.9", data_home: dir, env: {}, http_factory: http_factory,
+        bundler: ->(*) { nil }
+      )
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        bundle.send(:default_download, "https://downloads.example.test/archive", dest, max_bytes: 7)
+      end
+      assert_match(/download is too large/, error.message)
+      refute File.exist?(dest)
+    end
+  end
+
+  def test_local_bundle_attempt_honors_timeout_without_retry
+    runner = lambda do |*_args, **kwargs|
+      assert_equal 0.25, kwargs.fetch(:timeout)
+      raise Hive::BoundedSubprocess::TimeoutError.new(stdout: "", stderr: "", elapsed: 0.25)
+    end
+
+    with_tmp_dir do |dir|
+      app = write_rails_tree(File.join(dir, "app"))
+      File.write(File.join(app, "Gemfile.lock"), "GEM\n")
+      bundle = build(dir, subprocess_runner: runner, bundle_timeout: 0.25)
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        bundle.send(:default_bundle_install, app)
+      end
+      assert_match(/timed out after 0\.25s/, error.message)
+    end
+  end
+
+  def test_fallback_bundle_attempt_honors_timeout
+    calls = 0
+    failed_status = Struct.new(:success?).new(false)
+    runner = lambda do |*_args, **kwargs|
+      calls += 1
+      assert_equal 0.25, kwargs.fetch(:timeout)
+      return [ "", "not cached", failed_status ] if calls == 1
+
+      raise Hive::BoundedSubprocess::TimeoutError.new(stdout: "", stderr: "", elapsed: 0.25)
+    end
+
+    with_tmp_dir do |dir|
+      app = write_rails_tree(File.join(dir, "app"))
+      File.write(File.join(app, "Gemfile.lock"), "GEM\n")
+      bundle = build(dir, subprocess_runner: runner, bundle_timeout: 0.25)
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        bundle.send(:default_bundle_install, app)
+      end
+      assert_equal 2, calls
+      assert_match(/timed out after 0\.25s/, error.message)
+    end
+  end
+
+  def test_release_asset_naming_and_url_agree
+    bundle = build(Dir.mktmpdir)
+    assert_equal "hive-web-9.9.9.tar.gz", bundle.archive_basename
+    assert_equal(
+      "https://github.com/#{Hive::REPO_OWNER}/#{Hive::REPO_NAME}/releases/download/v9.9.9/hive-web-9.9.9.tar.gz",
+      bundle.release_asset_url
+    )
+  end
+
+  def test_paths_web_app_home_under_data_home
+    with_xdg_home do |_home|
+      assert_equal File.join(Hive::Paths.data_home, "web-app"), Hive::Paths.web_app_home
+      assert_equal File.join(Hive::Paths.web_app_home, ".hive-web-version"),
+                   Hive::Paths.web_app_version_stamp_path
+    end
+  end
+
+  def test_resolve_without_install_raises_when_nothing_available
+    with_tmp_dir do |dir|
+      bundle = build(dir, source_app_dir: File.join(dir, "nope"))
+      # This test runs inside a source checkout, so isolate the no-candidate
+      # branch explicitly rather than depending on the old broken traversal.
+      bundle.define_singleton_method(:rails_app?) { |_path| false }
+      error = assert_raises(Hive::Web::AppBundle::Error) do
+        bundle.resolve!(install: false)
+      end
+      assert_match(/no Rails app found/, error.message)
+    end
+  end
+
+  class FakeHttp
+    attr_accessor :use_ssl, :open_timeout, :read_timeout
+
+    def initialize(response)
+      @response = response
+    end
+
+    def request(_request)
+      yield @response
+    end
+  end
+end
diff --git a/test/unit/web/config_test.rb b/test/unit/web/config_test.rb
index a9ed2389..62f76455 100644
--- a/test/unit/web/config_test.rb
+++ b/test/unit/web/config_test.rb
@@ -10,10 +10,15 @@ class WebConfigTest < Minitest::Test
 
       assert_equal "127.0.0.1", cfg["bind"]
       assert_equal 4567, cfg["port"]
+      assert_equal true, cfg["local_loopback"]
       assert_match(/\.web\.session_secret\z/, cfg["session_secret_file"])
     end
   end
 
+  def test_local_loopback_must_be_boolean
+    assert_web_config_error({ "local_loopback" => "yes" }, /web\.local_loopback/)
+  end
+
   def test_invalid_web_port_is_rejected
     with_tmp_global_config do |home|
       File.write(File.join(home, "config.yml"), { "web" => { "port" => 70_000 } }.to_yaml)
diff --git a/test/unit/web/dispatcher_test.rb b/test/unit/web/dispatcher_test.rb
index a13e62db..caadb20d 100644
--- a/test/unit/web/dispatcher_test.rb
+++ b/test/unit/web/dispatcher_test.rb
@@ -426,4 +426,31 @@ Already answered
                    result[:argv]
     end
   end
+def test_queue_daemon_repair_writes_exact_maintenance_request
+  with_tmp_global_config do
+    request_id = Hive::Web::Dispatcher.new.queue_daemon_repair!
+    files = Dir[File.join(Hive::Paths.state_home, "dispatch_requests", "*.json")]
+    assert files.any?, "repair must write a dispatch request"
+    payload = JSON.parse(File.read(files.find { |f| File.read(f).include?(request_id) }))
+    assert_equal Hive::Daemon::DispatchRequestQueue::GLOBAL_PROJECT, payload["project"]
+    assert_equal Hive::Daemon::DispatchRequestQueue::GLOBAL_SLUG, payload["slug"]
+    assert_equal %w[hive daemon install --force], payload["argv"]
+    assert_equal "daemon_repair", payload["trigger"]
+    assert_equal "bot", payload["requestor"]
+  end
+end
+
+def test_non_maintenance_daemon_argv_rejected_at_write
+  with_tmp_global_config do
+    assert_raises(ArgumentError) do
+      Hive::Daemon::DispatchRequestQueue.write_request!(
+        project: Hive::Daemon::DispatchRequestQueue::GLOBAL_PROJECT,
+        slug: Hive::Daemon::DispatchRequestQueue::GLOBAL_SLUG,
+        argv: %w[hive daemon start],
+        requestor: "web",
+        trigger: "evil"
+      )
+    end
+  end
+end
 end
diff --git a/test/unit/web/web_command_test.rb b/test/unit/web/web_command_test.rb
index 11de4ab0..a645b674 100644
--- a/test/unit/web/web_command_test.rb
+++ b/test/unit/web/web_command_test.rb
@@ -1,18 +1,18 @@
 require "test_helper"
 require "hive/commands/web"
+require "hive/commands/web/service_installer"
 
 class WebCommandTest < Minitest::Test
   include HiveTestHelper
 
-  # `hive web` now boots the Rails app under web/; outside the container or
-  # a source checkout (no web/ dir, no HIVEBOX_WEB_APP_DIR) it must fail
-  # loudly with guidance instead of exec-ing into a missing app.
+  # `hive web` boots the Rails app via AppBundle; outside managed install,
+  # source checkout, or HIVEBOX_WEB_APP_DIR it must fail loudly.
   def test_missing_rails_app_exits_with_guidance
     with_tmp_global_config do
       with_env("HIVEBOX_WEB_APP_DIR" => File.join(Dir.mktmpdir("hive-noapp"), "nope")) do
         command = Hive::Commands::Web.new
-        # Singleton override instead of minitest/mock (not bundled): the
-        # checkout itself contains web/, so the fallback path would resolve.
+        # Singleton override: the checkout itself contains web/, so the
+        # fallback path would resolve without this stub.
         command.define_singleton_method(:rails_app_dir) { nil }
         err = assert_raises(SystemExit) do
           capture_io { command.call }
@@ -34,6 +34,107 @@ class WebCommandTest < Minitest::Test
     end
   end
 
+  def test_foreground_does_not_invoke_service_manager
+    with_tmp_global_config do
+      with_stub_rails_app(prepare_exit: 0) do
+        original = Kernel.method(:exec)
+        Kernel.define_singleton_method(:exec) do |env, *argv|
+          raise ExecCaught.new(env, argv)
+        end
+        # If service installer is required/used, fail.
+        called = false
+        Hive::Commands::Web::ServiceInstaller.define_singleton_method(:new) do |**|
+          called = true
+          raise "service installer must not run for foreground hive web"
+        end
+
+        begin
+          capture_io { Hive::Commands::Web.new.call }
+        rescue ExecCaught
+          # expected
+        ensure
+          Kernel.define_singleton_method(:exec, original)
+          Hive::Commands::Web::ServiceInstaller.singleton_class.send(:remove_method, :new)
+        end
+        refute called
+      end
+    end
+  end
+
+  def test_json_rejected_for_foreground
+    with_tmp_global_config do
+      error = assert_raises(Hive::InvalidTaskPath) do
+        capture_io { Hive::Commands::Web.new(json: true).call }
+      end
+      assert_match(/no JSON output|long-lived server/, error.message)
+    end
+  end
+
+  def test_install_subcommand_writes_unit
+    with_tmp_dir do |dir|
+      with_env("HOME" => dir) do
+        commands = []
+        installer = Hive::Commands::Web::ServiceInstaller.new(
+          host_os: "linux",
+          home: dir,
+          binary_path: "/tmp/hive",
+          systemctl_available: true,
+          runner: ->(argv) { commands << argv; true }
+        )
+        cmd = Hive::Commands::Web.new(subcommand: "install")
+        cmd.define_singleton_method(:service_installer) { installer }
+        out, = capture_io { cmd.call }
+        assert_match(/installed unit|up to date|upgraded/, out)
+        assert File.exist?(installer.target_path)
+      end
+    end
+  end
+
+  def test_json_status_reports_active_service_as_success
+    installer = Object.new
+    installer.define_singleton_method(:status_snapshot) do
+      {
+        "platform" => "linux", "service_installed" => true,
+        "service_enabled" => true, "service_active" => true,
+        "unit_path" => "/tmp/hive-web.service"
+      }
+    end
+    command = Hive::Commands::Web.new(subcommand: "status", json: true)
+    command.define_singleton_method(:service_installer) { installer }
+
+    out, = capture_io { command.call }
+    payload = JSON.parse(out)
+    assert payload["ok"]
+    assert_nil payload["error"]
+  end
+
+  def test_json_status_reports_inactive_service_and_raises
+    installer = Object.new
+    installer.define_singleton_method(:status_snapshot) do
+      {
+        "platform" => "linux", "service_installed" => true,
+        "service_enabled" => true, "service_active" => false,
+        "unit_path" => "/tmp/hive-web.service"
+      }
+    end
+    command = Hive::Commands::Web.new(subcommand: "status", json: true)
+    command.define_singleton_method(:service_installer) { installer }
+
+    error = nil
+    out, = capture_io do
+      begin
+        command.call
+      rescue Hive::Error => e
+        error = e
+      end
+    end
+    assert_instance_of Hive::Error, error
+    assert_equal "web service not active", error.message
+    payload = JSON.parse(out)
+    refute payload["ok"]
+    assert_equal "web service not active", payload["error"]
+  end
+
   def test_public_bind_without_https_origin_warns
     with_tmp_global_config do
       command = Hive::Commands::Web.new
@@ -115,4 +216,41 @@ class WebCommandTest < Minitest::Test
       end
     end
   end
+
+  def test_managed_bundle_runtime_env_reaches_database_prepare_and_rails
+    with_xdg_home do
+      app_dir = Hive::Web::AppBundle.new.managed_app_dir
+      FileUtils.mkdir_p(File.join(app_dir, "config"))
+      FileUtils.mkdir_p(File.join(app_dir, "bin"))
+      File.write(File.join(app_dir, "config", "application.rb"), "# rails app marker\n")
+      File.write(File.join(app_dir, "Gemfile"), "source \"https://rubygems.org\"\n")
+      File.write(File.join(app_dir, Hive::Web::AppBundle::VERSION_STAMP_NAME), "#{Hive::VERSION}\n")
+      File.write(File.join(app_dir, "bin", "rails"), <<~SH)
+        #!/usr/bin/env bash
+        [ "$1" = "db:prepare" ] || exit 1
+        [ "$BUNDLE_PATH" = "#{File.join(app_dir, 'vendor', 'bundle')}" ] || exit 2
+        exit 0
+      SH
+      FileUtils.chmod(0o755, File.join(app_dir, "bin", "rails"))
+
+      original = Kernel.method(:exec)
+      Kernel.define_singleton_method(:exec) do |env, *argv|
+        raise ExecCaught.new(env, argv)
+      end
+
+      caught = nil
+      begin
+        capture_io { Hive::Commands::Web.new.call }
+      rescue ExecCaught => e
+        caught = e
+      ensure
+        Kernel.define_singleton_method(:exec, original)
+      end
+
+      refute_nil caught
+      assert_equal File.join(app_dir, "vendor", "bundle"), caught.env["BUNDLE_PATH"]
+      assert_equal "1", caught.env["BUNDLE_DEPLOYMENT"]
+      assert_equal File.join(app_dir, "Gemfile"), caught.env["BUNDLE_GEMFILE"]
+    end
+  end
 end
diff --git a/web/Gemfile b/web/Gemfile
index 53710d90..1ef3aaa5 100644
--- a/web/Gemfile
+++ b/web/Gemfile
@@ -70,4 +70,7 @@ end
 # The hive control plane: status payloads, gate approval, daemon dispatch,
 # the GitHub device-flow gate, the agent OAuth relay, and Telegram
 # validation all come from the gem — the web tier adds no pipeline logic.
+# Source checkouts use the sibling gemspec. release.yml rewrites only its
+# tracked staging copy to an exact version and an unpacked vendor/hive-cli
+# path, so the published web archive has no parent-path dependency.
 gem "hive-cli", path: ".."
diff --git a/web/app/controllers/application_controller.rb b/web/app/controllers/application_controller.rb
index 2a1e5e28..b1749a0f 100644
--- a/web/app/controllers/application_controller.rb
+++ b/web/app/controllers/application_controller.rb
@@ -50,6 +50,8 @@ class ApplicationController < ActionController::Base
   end
 
   def require_login
+    return if local_loopback_request?
+
     return redirect_to login_path unless current_login
 
     # Sessions must track the CURRENT owner, not the owner at sign-in time:
@@ -65,6 +67,21 @@ class ApplicationController < ActionController::Base
     redirect_to login_path, alert: "Signed out: this box's owner changed."
   end
 
+  # Local single-user mode: CLI sets HIVE_WEB_LOCAL_LOOPBACK only for a
+  # loopback bind, and we re-check both the actual peer and the HTTP Host.
+  # The Host check is load-bearing: accepting an arbitrary hostname merely
+  # because its TCP peer is loopback would let DNS rebinding turn a browser
+  # on the operator's machine into an unauthenticated deputy.
+  def local_loopback_request?
+    return false unless Hive::Web::Loopback.mode_enabled?
+    return false unless Hive::Config.load_global_web.fetch("local_loopback", true)
+
+    Hive::Web::Loopback.address?(request.remote_ip) &&
+      Hive::Web::Loopback.address?(request.host)
+  rescue StandardError
+    false
+  end
+
   def registered_projects
     @registered_projects ||= Hive::Config.registered_projects
   end
